=== bx_debug/Makefile ===
# Copyright (C) 2001  MandrakeSoft S.A.
#
#   MandrakeSoft S.A.
#   43, rue d'Aboukir
#   75002 Paris - France
#   http://www.linux-mandrake.com/
#   http://www.mandrakesoft.com/
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA



.SUFFIXES: .cc

srcdir = .

top_builddir    = ..
top_srcdir      = ..

SHELL = /bin/sh



CC = gcc
CFLAGS = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT
CXX = g++
CXXFLAGS = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT

LDFLAGS = 
LIBS =  -lm
RANLIB = ranlib

# Definitely use flex.  Use flex version >= 2.5.4
# Flex version 2.5.2 was reported not to work
LEX    = flex
YACC   = yacc


# ===========================================================
# end of configurable options
# ===========================================================


BX_OBJS = \
  dbg_main.o \
  symbols.o \
  linux.o \

BX_PARSER_OBJS = \
  parser.o \
  lexer.o

BX_INCLUDES = debug.h

BX_INCDIRS = -I.. -I$(srcdir)/.. -I../instrument/stubs -I$(srcdir)/../instrument/stubs -I. -I$(srcdir)/.

all: libdebug.a

.cc.o:
	$(CXX) -c $(BX_INCDIRS) $(CXXFLAGS) $< -o $@


.c.o:
	$(CC) -c $(BX_INCDIRS) $(CFLAGS) $< -o $@



libdebug.a: $(BX_OBJS) $(BX_PARSER_OBJS)
	rm -f  libdebug.a
	ar rv $@ $(BX_OBJS) $(BX_PARSER_OBJS)
	$(RANLIB) libdebug.a

$(BX_OBJS): $(BX_INCLUDES)


clean:
	rm -f  *.o
	rm -f  libdebug.a

dist-clean: clean
	rm -f  Makefile

parse-clean:
	rm -f  -f  lexer.c
	rm -f  -f  parser.c
	rm -f  -f  parser.h

dbg_main.o: debug.h
sim2.o: debug.h

parser.c: parser.y
	@/bin/rm -f y.tab.c parser.c
	@/bin/rm -f y.tab.h parser.h
	$(YACC) -p bx -d $<
	@/bin/mv -f y.tab.c parser.c
	@/bin/mv -f y.tab.h parser.h
	@echo '#endif  /* if BX_DEBUGGER */' >> parser.c
	@echo '/* The #endif is appended by the makefile after running yacc. */' >> parser.c

lexer.c: lexer.l
	$(LEX) -Pbx -t $< > lexer.c

###########################################
# dependencies generated by
#  gcc -MM -I. -I.. -I../instrument/stubs *.c  *.cc | sed 's/\.cc/.cc/g'
###########################################
lexer.o: lexer.c debug.h ../config.h ../osdep.h
parser.o: parser.c debug.h ../config.h ../osdep.h
dbg_main.o: dbg_main.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../bxversion.h ../gui/siminterface.h ../cpu/cpu.h \
  ../cpu/instr.h ../cpu/crregs.h ../cpu/lazy_flags.h  ../cpu/icache.h \
  ../cpu/apic.h ../cpu/i387.h ../fpu/softfloat.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../memory/memory.h \
  ../pc_system.h ../plugin.h ../extplugin.h ../ltdl.h ../gui/gui.h  \
  ../gui/textconfig.h ../gui/keymap.h ../instrument/stubs/instrument.h \
  ../iodev/iodev.h ../iodev/pci.h ../iodev/pci2isa.h ../iodev/pci_ide.h \
  ../iodev/pcivga.h ../iodev/pcidev.h ../iodev/pciusb.h ../iodev/vga.h \
  ../iodev/ioapic.h ../iodev/biosdev.h ../iodev/cmos.h ../iodev/dma.h \
  ../iodev/floppy.h ../iodev/harddrv.h ../iodev/keyboard.h \
  ../iodev/parallel.h ../iodev/pic.h ../iodev/pit_wrap.h ../iodev/pit82c54.h \
  ../iodev/virt_timer.h ../iodev/serial.h ../iodev/sb16.h \
  ../iodev/unmapped.h ../iodev/ne2k.h ../iodev/guest2host.h \
  ../iodev/slowdown_timer.h ../iodev/extfpuirq.h ../iodev/gameport.h
linux.o: linux.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../bxversion.h ../gui/siminterface.h ../cpu/cpu.h ../cpu/instr.h \
  ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h ../cpu/i387.h ../cpu/crregs.h \
  ../fpu/softfloat.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../ltdl.h ../gui/gui.h ../gui/textconfig.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h
symbols.o: symbols.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../bxversion.h ../gui/siminterface.h ../cpu/cpu.h ../cpu/instr.h \
  ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h ../cpu/i387.h ../cpu/crregs.h \
  ../fpu/softfloat.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../ltdl.h ../gui/gui.h ../gui/textconfig.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h
