=== cpu/Makefile ===
# Copyright (C) 2001  MandrakeSoft S.A.
#
#   MandrakeSoft S.A.
#   43, rue d'Aboukir
#   75002 Paris - France
#   http://www.linux-mandrake.com/
#   http://www.mandrakesoft.com/
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA


.SUFFIXES: .cc

srcdir = .

top_builddir    = ..
top_srcdir      = ..

SHELL = /bin/sh



CXX = g++
CXXFLAGS = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT

LDFLAGS = 
LIBS =  -lm
X_LIBS = 
X_PRE_LIBS =  -lSM -lICE
RANLIB = ranlib



BX_INCDIRS = -I.. -I$(srcdir)/.. -I../instrument/stubs -I$(srcdir)/../instrument/stubs

EXT_DEBUG_OBJS = 

# Objects which are synced between the cpu and cpu64 code and
# are used for either compile.
OBJS = \
	init.o \
	cpu.o \
	icache.o \
	resolve.o \
	fetchdecode.o \
	access.o \
	shift16.o \
	logical16.o \
	ctrl_xfer32.o \
	ctrl_xfer16.o \
	mmx.o \
	3dnow.o \
	fpu_emu.o \
	sse.o \
	sse_move.o \
	sse_pfp.o \
	sse_rcp.o \
	sse_string.o \
	xsave.o \
	aes.o \
	soft_int.o \
	io_pro.o \
	apic.o \
	bcd.o \
	mult16.o \
	tasking.o \
	shift32.o \
	shift8.o \
	arith8.o \
	stack16.o \
	protect_ctrl.o \
	mult8.o \
	data_xfer8.o \
	vm8086.o \
	logical8.o \
	logical32.o \
	arith16.o \
	segment_ctrl.o \
	ctrl_xfer8.o \
	data_xfer16.o \
	data_xfer32.o \
	exception.o \
	cpuid.o \
	proc_ctrl.o \
	smm.o \
	lazy_flags.o \
	flag_ctrl_pro.o \
	stack32.o \
	debugstuff.o \
	flag_ctrl.o \
	mult32.o \
	arith32.o \
	jmp_far.o \
	call_far.o \
	ret_far.o \
	iret.o \
	ctrl_xfer_pro.o \
	segment_ctrl_pro.o \
	io.o \
	bit.o \
	bit16.o \
	bit32.o \
	string.o \
	paging.o \
	$(EXT_DEBUG_OBJS)
	
# Objects which are only used for x86-64 code
OBJS64 = \
	access64.o \
	arith64.o \
	ctrl_xfer64.o \
	data_xfer64.o \
	fetchdecode64.o \
	logical64.o \
	mult64.o \
	shift64.o \
	bit64.o \
	stack64.o

BX_INCLUDES = ../bochs.h ../config.h


all: libcpu.a

.cc.o:
	$(CXX) -c $(BX_INCDIRS) $(CXXFLAGS) $< -o $@


libcpu.a: $(OBJS) 
	rm -f  libcpu.a
	ar rv $@ $(OBJS) 
	$(RANLIB) libcpu.a

$(OBJS): $(BX_INCLUDES)

$(OBJS64): $(BX_INCLUDES)

clean:
	rm -f  *.o
	rm -f  *.a

dist-clean: clean
	rm -f  Makefile

###########################################
# dependencies generated by
#  gcc -MM -I.. -I../instrument/stubs *.cc | sed 's/\.cc/.cc/g'
###########################################
3dnow.o: 3dnow.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
access.o: access.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
access64.o: access64.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
apic.o: apic.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h \
  ../iodev/iodev.h ../bochs.h ../iodev/pci.h ../iodev/pci2isa.h \
  ../iodev/pci_ide.h ../iodev/acpi.h ../iodev/pcivga.h ../iodev/vga.h \
  ../iodev/svga_cirrus.h ../iodev/ioapic.h ../cpu/apic.h \
  ../iodev/biosdev.h ../iodev/cmos.h ../iodev/dma.h ../iodev/floppy.h \
  ../iodev/harddrv.h ../iodev/keyboard.h ../iodev/parallel.h \
  ../iodev/pic.h ../iodev/pit_wrap.h ../iodev/pit82c54.h \
  ../iodev/virt_timer.h ../iodev/serial.h ../iodev/unmapped.h \
  ../iodev/ne2k.h ../iodev/guest2host.h ../iodev/slowdown_timer.h \
  ../iodev/extfpuirq.h ../iodev/gameport.h
arith16.o: arith16.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h cpu.h \
  ../disasm/disasm.h ../config.h crregs.h descriptor.h instr.h \
  lazy_flags.h icache.h apic.h ../cpu/i387.h ../fpu/softfloat.h \
  ../config.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h stack.h
arith32.o: arith32.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h cpu.h \
  ../disasm/disasm.h ../config.h crregs.h descriptor.h instr.h \
  lazy_flags.h icache.h apic.h ../cpu/i387.h ../fpu/softfloat.h \
  ../config.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h stack.h
arith64.o: arith64.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h cpu.h \
  ../disasm/disasm.h ../config.h crregs.h descriptor.h instr.h \
  lazy_flags.h icache.h apic.h ../cpu/i387.h ../fpu/softfloat.h \
  ../config.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h stack.h
arith8.o: arith8.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
bcd.o: bcd.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
bit.o: bit.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
bit16.o: bit16.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
bit32.o: bit32.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
bit64.o: bit64.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h
call_far.o: call_far.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h cpu.h \
  ../disasm/disasm.h ../config.h crregs.h descriptor.h instr.h \
  lazy_flags.h icache.h apic.h ../cpu/i387.h ../fpu/softfloat.h \
  ../config.h ../fpu/tag_w.h ../fpu/status_w.h ../fpu/control_w.h \
  ../cpu/xmm.h stack.h
cpu.o: cpu.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h cpu.h ../disasm/disasm.h ../config.h \
  crregs.h descriptor.h instr.h lazy_flags.h icache.h apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h stack.h \
  ../iodev/iodev.h ../bochs.h ../iodev/pci.h ../iodev/pci2isa.h \
  ../iodev/pci_ide.h ../iodev/acpi.h ../iodev/pcivga.h ../iodev/vga.h \
  ../iodev/svga_cirrus.h ../iodev/ioapic.h ../cpu/apic.h \
  ../iodev/biosdev.h ../iodev/cmos.h ../iodev/dma.h ../iodev/floppy.h \
  ../iodev/harddrv.h ../iodev/keyboard.h ../iodev/parallel.h \
  ../iodev/pic.h ../iodev/pit_wrap.h ../iodev/pit82c54.h \
  ../iodev/virt_timer.h ../iodev/serial.h ../iodev/unmapped.h \
