=== fpu/Makefile ===
# Copyright (C) 2001  MandrakeSoft S.A.
#
#   MandrakeSoft S.A.
#   43, rue d'Aboukir
#   75002 Paris - France
#   http://www.linux-mandrake.com/
#   http://www.mandrakesoft.com/
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

.SUFFIXES: .cc

srcdir = .

top_builddir    = ..
top_srcdir      = ..

SHELL = /bin/sh



CC       = gcc
CFLAGS   = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT
CXX      = g++
CXXFLAGS = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT

#CFLAGS  = -Wall -Wstrict-prototypes -fomit-frame-pointer -fno-strict-aliasing -pipe -fno-strength-reduce -mpreferred-stack-boundary=2 -DCPU=686 -march=i686

LDFLAGS    = 
LIBS       =  -lm
RANLIB     = ranlib

L_TARGET = libfpu.a


BX_INCDIRS = -I.. -I$(srcdir)/.. -I../instrument/stubs -I$(srcdir)/../instrument/stubs -I. -I$(srcdir)/. -I./stubs -I$(srcdir)/./stubs

OBJS = ferr.o fpu.o fpu_arith.o fpu_compare.o fpu_const.o \
               fpu_load_store.o fpu_misc.o fpu_trans.o fpu_tags.o \
               fprem.o fsincos.o f2xm1.o fyl2x.o fpatan.o \
               softfloat.o softfloatx80.o softfloat-specialize.o \
               softfloat-round-pack.o poly.o

all: libfpu.a

.cc.o:
	$(CXX) -c $(BX_INCDIRS) $(CXXFLAGS) $< -o $@

.c.o:
	$(CC) -c $(CFLAGS) $(BX_INCDIRS) $< -o $@


libfpu.a: $(OBJS)
	rm -f  libfpu.a
	ar rv $@ $(OBJS)
	$(RANLIB) libfpu.a

clean:
	rm -f  *.o
	rm -f  *.a

dist-clean: clean
	rm -f  Makefile

###########################################
# dependencies generated by
#  gcc -MM -I.. -I../instrument/stubs *.cc | sed -e 's/\.cc/.cc/g'
###########################################
f2xm1.o: f2xm1.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-macros.h softfloat-round-pack.h
ferr.o: ferr.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h ../cpu/cpu.h ../disasm/disasm.h \
  ../config.h ../cpu/crregs.h ../cpu/descriptor.h ../cpu/instr.h \
  ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h ../cpu/i387.h \
  ../fpu/softfloat.h ../config.h ../fpu/tag_w.h ../fpu/status_w.h \
  ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h softfloat-specialize.h \
  softfloat.h
fpatan.o: fpatan.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-macros.h softfloat-round-pack.h \
  fpu_constant.h
fprem.o: fprem.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-round-pack.h softfloat-macros.h
fpu.o: fpu.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h ../cpu/cpu.h ../disasm/disasm.h \
  ../config.h ../cpu/crregs.h ../cpu/descriptor.h ../cpu/instr.h \
  ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h ../cpu/i387.h \
  ../fpu/softfloat.h ../config.h ../fpu/tag_w.h ../fpu/status_w.h \
  ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h ../iodev/iodev.h \
  ../bochs.h ../iodev/pci.h ../iodev/pci2isa.h ../iodev/pci_ide.h \
  ../iodev/acpi.h ../iodev/pcivga.h ../iodev/vga.h ../iodev/svga_cirrus.h \
  ../iodev/ioapic.h ../cpu/apic.h ../iodev/biosdev.h ../iodev/cmos.h \
  ../iodev/dma.h ../iodev/floppy.h ../iodev/harddrv.h ../iodev/keyboard.h \
  ../iodev/parallel.h ../iodev/pic.h ../iodev/pit_wrap.h \
  ../iodev/pit82c54.h ../iodev/virt_timer.h ../iodev/serial.h \
  ../iodev/unmapped.h ../iodev/ne2k.h ../iodev/guest2host.h \
  ../iodev/slowdown_timer.h ../iodev/extfpuirq.h ../iodev/gameport.h
fpu_arith.o: fpu_arith.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h
fpu_compare.o: fpu_compare.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h \
  softfloatx80.h softfloat.h softfloat-specialize.h
fpu_const.o: fpu_const.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h \
  softfloatx80.h softfloat.h softfloat-specialize.h
fpu_load_store.o: fpu_load_store.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h \
  softfloatx80.h softfloat.h softfloat-specialize.h
fpu_misc.o: fpu_misc.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h \
  softfloatx80.h softfloat.h softfloat-specialize.h
fpu_tags.o: fpu_tags.cc ../config.h softfloat.h ../config.h \
  softfloat-specialize.h ../cpu/i387.h ../fpu/softfloat.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h
fpu_trans.o: fpu_trans.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../disasm/disasm.h ../config.h ../cpu/crregs.h ../cpu/descriptor.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../cpu/stack.h \
  softfloatx80.h softfloat.h softfloat-specialize.h
fsincos.o: fsincos.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-macros.h softfloat-round-pack.h \
  fpu_constant.h
fyl2x.o: fyl2x.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-macros.h softfloat-round-pack.h \
  fpu_constant.h
poly.o: poly.cc softfloat.h ../config.h
softfloat-round-pack.o: softfloat-round-pack.cc softfloat.h ../config.h \
  softfloat-round-pack.h softfloat-macros.h softfloat-specialize.h
softfloat-specialize.o: softfloat-specialize.cc softfloat.h ../config.h \
  softfloat-specialize.h softfloat-macros.h
softfloat.o: softfloat.cc softfloat.h ../config.h softfloat-round-pack.h \
  softfloat-macros.h softfloat-specialize.h
softfloatx80.o: softfloatx80.cc softfloatx80.h softfloat.h ../config.h \
  softfloat-specialize.h softfloat-round-pack.h softfloat-macros.h
