=== memory/Makefile ===
# Copyright (C) 2001  MandrakeSoft S.A.
#
#   MandrakeSoft S.A.
#   43, rue d'Aboukir
#   75002 Paris - France
#   http://www.linux-mandrake.com/
#   http://www.mandrakesoft.com/
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA


.SUFFIXES: .cc

srcdir = .

top_builddir    = ..
top_srcdir      = ..

SHELL = /bin/sh



CXX = g++
CXXFLAGS = -g -O2 -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES  -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT

LDFLAGS = 
LIBS =  -lm
X_LIBS = 
X_PRE_LIBS =  -lSM -lICE
RANLIB = ranlib


BX_INCDIRS = -I.. -I$(srcdir)/.. -I../instrument/stubs -I$(srcdir)/../instrument/stubs

BX_OBJS = \
	memory.o misc_mem.o

BX_INCLUDES = ../bochs.h ../config.h

all: libmemory.a

.cc.o:
	$(CXX) -c $(BX_INCDIRS) $(CXXFLAGS) $< -o $@


libmemory.a: $(BX_OBJS)
	rm -f  libmemory.a
	ar rv $@ $(BX_OBJS)
	$(RANLIB) libmemory.a

$(BX_OBJS): $(BX_INCLUDES)

clean:
	rm -f  *.o
	rm -f  *.a

dist-clean: clean
	rm -f  Makefile

###########################################
# dependencies generated by
#  gcc -MM -I.. -I../instrument/stubs *.cc | sed 's/\.cc/.cc/g'
###########################################
memory.o: memory.cc ../bochs.h ../config.h ../osdep.h ../bx_debug/debug.h \
  ../config.h ../osdep.h ../bxversion.h ../gui/siminterface.h \
  ../memory/memory.h ../pc_system.h ../plugin.h ../extplugin.h \
  ../gui/gui.h ../gui/textconfig.h ../config.h ../gui/keymap.h \
  ../instrument/stubs/instrument.h ../cpu/cpu.h ../cpu/instr.h \
  ../cpu/lazy_flags.h ../disasm/disasm.h ../config.h ../cpu/crregs.h \
  ../cpu/descriptor.h ../cpu/icache.h ../cpu/apic.h ../cpu/i387.h \
  ../fpu/softfloat.h ../config.h ../fpu/tag_w.h ../fpu/status_w.h \
  ../fpu/control_w.h ../cpu/xmm.h ../iodev/iodev.h ../bochs.h \
  ../iodev/pci.h ../iodev/pci2isa.h ../iodev/pci_ide.h ../iodev/acpi.h \
  ../iodev/pcivga.h ../iodev/vga.h ../iodev/svga_cirrus.h \
  ../iodev/ioapic.h ../cpu/apic.h ../iodev/biosdev.h ../iodev/cmos.h \
  ../iodev/dma.h ../iodev/floppy.h ../iodev/harddrv.h ../iodev/keyboard.h \
  ../iodev/parallel.h ../iodev/pic.h ../iodev/pit_wrap.h \
  ../iodev/pit82c54.h ../iodev/virt_timer.h ../iodev/serial.h \
  ../iodev/unmapped.h ../iodev/ne2k.h ../iodev/guest2host.h \
  ../iodev/slowdown_timer.h ../iodev/extfpuirq.h ../iodev/gameport.h
misc_mem.o: misc_mem.cc ../bochs.h ../config.h ../osdep.h \
  ../bx_debug/debug.h ../config.h ../osdep.h ../bxversion.h \
  ../gui/siminterface.h ../memory/memory.h ../pc_system.h ../plugin.h \
  ../extplugin.h ../gui/gui.h ../gui/textconfig.h ../config.h \
  ../gui/keymap.h ../instrument/stubs/instrument.h ../cpu/cpu.h \
  ../cpu/instr.h ../cpu/lazy_flags.h ../disasm/disasm.h ../config.h \
  ../cpu/crregs.h ../cpu/descriptor.h ../cpu/icache.h ../cpu/apic.h \
  ../cpu/i387.h ../fpu/softfloat.h ../config.h ../fpu/tag_w.h \
  ../fpu/status_w.h ../fpu/control_w.h ../cpu/xmm.h ../iodev/iodev.h \
  ../bochs.h ../iodev/pci.h ../iodev/pci2isa.h ../iodev/pci_ide.h \
  ../iodev/acpi.h ../iodev/pcivga.h ../iodev/vga.h ../iodev/svga_cirrus.h \
  ../iodev/ioapic.h ../cpu/apic.h ../iodev/biosdev.h ../iodev/cmos.h \
  ../iodev/dma.h ../iodev/floppy.h ../iodev/harddrv.h ../iodev/keyboard.h \
  ../iodev/parallel.h ../iodev/pic.h ../iodev/pit_wrap.h \
  ../iodev/pit82c54.h ../iodev/virt_timer.h ../iodev/serial.h \
  ../iodev/unmapped.h ../iodev/ne2k.h ../iodev/guest2host.h \
  ../iodev/slowdown_timer.h ../iodev/extfpuirq.h ../iodev/gameport.h
