=== debian/changelog ===
bochs (2.3.7-maemo2) unstable; urgency=low

  * Fixed section in debian/control

 -- Toni Nikkanen <toni@tuug.fi>  Wed,  17 Mar 2010 19:45:16 +0200
