=== debian/control ===
Source: bochs
Section: user/other
Priority: extra
Maintainer: Toni Nikkanen <toni@tuug.fi>
Build-Depends: debhelper (>= 5), quilt (>= 0.40),
 autoconf, libz-dev, libreadline5-dev | libreadline-dev,
 libx11-dev, libxpm-dev, libice-dev,
 libsm-dev, libsdl1.2-dev
Standards-Version: 3.7.2

Package: bochs
Architecture: any
Depends: ${shlibs:Depends}
Description: IA-32 PC emulator
 Bochs is a highly portable free IA-32 (x86) PC emulator written in C++, that
 runs on most popular platforms. It includes emulation of the Intel x86 CPU,
 common I/O devices, and a custom BIOS.
 .
 Bochs is capable of running most operating systems inside the emulation
 including GNU, GNU/Linux, *BSD, FreeDOS, MSDOS and Windows 95/NT.
