=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1





CFLAGS = -O2


configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp
	./configure --prefix=/opt/bochs --enable-pci --enable-clgd54xx --enable-apic --with-sdl --enable-all-optimizations



build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	make -j2
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean
	find . -name *.a|xargs rm -vf
	find . -name *.o|xargs rm -vf

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

        # Add here commands to install the package into debian/bochs.
	mkdir -p debian/bochs/opt/bochs/bin
	for i in bochs bximage bxcommit; do if test -f $$i; then install $$i debian/bochs/opt/bochs/bin; else install ./$$i debian/bochs/opt/bochs/bin; fi; done
	for i in debian/bochs/opt/bochs/share/bochs;	do mkdir -p $$i && test -d $$i && test -w $$i; done
	for i in bios/BIOS-bochs-* bios/VGABIOS* ; do if test -f $$i; then install -m 644 $$i debian/bochs/opt/bochs/share/bochs; else install -m 644 ./$$i debian/bochs/opt/bochs/share/bochs; fi; done
	mkdir debian/bochs/opt/bochs/share/bochs/keymaps
	for i in ./gui/keymaps/*.map; do install -m 644 $$i debian/bochs/opt/bochs/share/bochs/keymaps/; done
	for i in debian/bochs/opt/bochs/share/doc/bochs; do mkdir -p $$i && test -d $$i && test -w $$i; done
	for i in CHANGES COPYING README TODO; do if test -f $$i; then install -m 644 $$i debian/bochs/opt/bochs/share/doc/bochs; else install -m 644 ./$$i debian/bochs/opt/bochs/share/doc/bochs; fi; done
	rm -f debian/bochs/opt/bochs/share/doc/bochs/README
	cat ./build/linux/README.linux-binary ./README > debian/bochs/opt/bochs/share/doc/bochs/README
	install -m 644 ./.bochsrc debian/bochs/opt/bochs/share/doc/bochs/bochsrc-sample.txt


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
